unit ReceiveFIDThread;

interface

uses
  Classes, D2XXUnit, windows, StdCtrls, SysUtils, Graphics, ExtCtrls,FIDUNit,
  math;

type
  TReceiveFIDThread = class(TThread)
  private
    { Private 錾 }
    FHandle: DWord;
   // FMemo: TMemo;
    FFT_In_Buffer: array[0..7] of byte;
    FRead_Result: integer;
    FAL: cardinal;
    FNA: cardinal;
    FCA: cardinal;
    FSTEP: cardinal;
    FAccumFinished: boolean;
    count2:cardinal;

    FTransferBusy:boolean;

    FReady:boolean;
    cst:word;

    FReal32:integer;
    FImag32:integer;


    FT_Q:DWord;
    xr,xi,c,s: double;
    timeout: boolean;



    procedure plotData;
    procedure acquireData;



  protected
    procedure Execute; override;

  public
    FID:TFID;
    repeatScan:boolean;
    fft_repeatScan:boolean;
    spinNoise: boolean;

    dfScaleCorrection:single;

    property transferBusy:boolean read FTransferBusy;
    property accumFinished: boolean read FAccumFinished;
    property al: cardinal read FAL;
    property na: cardinal read FNA;
    property ca: cardinal read FCA;
    property step: cardinal read FSTEP;

    property ready: boolean read FReady;

    constructor Create(Handle:DWord; al,na,step:cardinal); virtual;
    destructor Free;

  end;

implementation

uses main;
//------------------------------------------------------------------------------
constructor TReceiveFIDThread.Create(Handle:DWord; al,na,step:cardinal);
begin
  FHandle := Handle;
 // FMemo := memo;
  FAL := al;
  FNA := na;
  FCA := 0;
  FSTEP := step;
  FAccumFinished := false;
//  FAcqFinished := false;

  FID:=TFID.create(al);
  repeatScan:=false;
  fft_repeatScan:=false;
  spinNoise := false;

  inherited Create(False);
  FreeOnTerminate := True;

  FReady:=false;
  FTransferBusy:=false;

  dfScaleCorrection:=1.0;

end;
//------------------------------------------------------------------------------
destructor TReceiveFIDThread.Free;
begin
  FID.free;
end;
//------------------------------------------------------------------------------
procedure TReceiveFIDThread.plotData;
var s,s2:string;
    c:cardinal;
begin
    c:=ca+step;
    if c>na*nacq then c:=na*nacq;

    s:='';
    if nst>1 then begin
      s:=' ('+ IntToStr(cst+1) +')';
     // if cst=0 then s:=' (Real)' else s:=' (Imag)';
    end;

    s2:='';
    if nacq>1 then s2:=' x '+IntToStr(nacq);

    if not repeatScan then
      MainForm.acqCountEdit.Text := IntToStr(c) + s
                                      + '/' + IntToStr(na) + s2
                                      + acqCountText
      else MainForm.acqCountEdit.Text :='Repeat scan';

    FID_2D.draw(MainForm.FIDPaintBox, FID_2D.length_2D-nst+cst);
    FID_2D.drawCursor(MainForm.FIDPaintBox);


    FReady:=true;
end;
//------------------------------------------------------------------------------
procedure TReceiveFIDThread.acquireData;

begin
        FT_GetQueueStatus(FHandle, @FT_Q);
          if FT_Q>=8 then begin

            FTransferBusy:=true;

            FT_Read(FHandle,@FFT_In_Buffer,8,@FRead_Result);

            FReal32 := (FFT_In_Buffer[0] shl 24)
                     + (FFT_In_Buffer[1] shl 16)
                     + (FFT_In_Buffer[2] shl 8)
                      + FFT_In_Buffer[3];

            FImag32 :=  (FFT_In_Buffer[4] shl 24)
                     + (FFT_In_Buffer[5] shl 16)
                     + (FFT_In_Buffer[6] shl 8)
                     + FFT_In_Buffer[7];


            FID.imag.sig[count2]:=dfScaleCorrection*FImag32;
            FID.real.sig[count2]:=dfScaleCorrection*FReal32;

            if spinNoise then
               FID.abs.sig[count2]:=
                  sqrt(FID.imag.sig[count2]*FID.imag.sig[count2]
                     + FID.real.sig[count2]*FID.real.sig[count2]);

            if not spinNoise then begin
              // Acq phase

              xr:=FID.real.sig[count2];
              xi:=FID.imag.sig[count2];
              FID.real.sig[count2] := c*xr - s*xi;
              FID.imag.sig[count2] := c*xi + s*xr;

            if repeatScan then begin

              FID_2D.FID[FID_2D.length_2D-nst+cst].imag.sig[count2]:=
                     FID.imag.sig[count2];

              FID_2D.FID[FID_2D.length_2D-nst+cst].real.sig[count2]:=
                     FID.real.sig[count2];

              FID_2D.FID[FID_2D.length_2D-nst+cst].abs.sig[count2]:=
                sqrt(sqr(FID_2D.FID[FID_2D.length_2D-nst+cst].real.sig[count2])
                 +sqr(FID_2D.FID[FID_2D.length_2D-nst+cst].imag.sig[count2]));


            end else begin
              FID_2D.FID[FID_2D.length_2D-nst+cst].imag.sig[count2]:=
                     FID_2D.FID[FID_2D.length_2D-nst+cst].imag.sig[count2]
                            + FID.imag.sig[count2];

              FID_2D.FID[FID_2D.length_2D-nst+cst].real.sig[count2]:=
                     FID_2D.FID[FID_2D.length_2D-nst+cst].real.sig[count2]
                            + FID.real.sig[count2];

              FID_2D.FID[FID_2D.length_2D-nst+cst].abs.sig[count2]:=
                sqrt(sqr(FID_2D.FID[FID_2D.length_2D-nst+cst].real.sig[count2])
                 +sqr(FID_2D.FID[FID_2D.length_2D-nst+cst].imag.sig[count2]));

            end; // repeatScan

            end;  // not spinNoise

            inc(count2);

          //  FTransferBusy:=false;

          end else begin // if FT_Q>=8
            if (GetTickCount-msec)>3000 then timeout:=true;
            sleep(1); // 1.00beta7
          end;


end;

//------------------------------------------------------------------------------
procedure TReceiveFIDThread.Execute;
var
    q:word;

    phi:double;
    msec:cardinal;
begin
  { ToDo : XbhƂĎsR[hɋLq }
 // FT_SetTimeouts(FHandle,1000,1000);

  for q:=0 to nst-1 do begin
    FID_2D.add;
  end;
  cst:=0; // cst[ɃZbgB

  FAccumFinished:=false;

  FCA:=0;

  phi:=3.14159265358979*FID_2D.acqPhase/180.0;  // degree -> radian conversion
  c:=cos(phi);
  s:=sin(phi);

  while ((not terminated) and (not accumFinished)) do begin

    count2:=0; FtransferBusy:=false;

    if repeatScan then begin
      phi:=3.14159265358979*FID_2D.acqPhase/180.0;  // degree -> radian conversion
      c:=cos(phi);
      s:=sin(phi);
    end;

    repeat
      FT_GetQueueStatus(FHandle, @FT_Q);
      sleep(1);
    until (FT_Q>=1) or (terminated);

    if terminated then break;
    if dataSaveBusy then repeat until dataSaveBusy=false;


    FTransferBusy:=true;
    msec:=GetTickCount; timeout:=false;

      while ((not terminated) and (count2<=FAL-1) and (not timeout)) do begin

        synchronize(acquireData);

      end; // while (count2<=FAL-1)

      if terminated then break;


      FTransferBusy:=false;

      if fft_repeatScan then begin
        FID.FFT;
        FID_2D.FID[FID_2D.length_2D-1].domain:=dmFrequency;
        for q:=0 to al-1 do begin
          FID_2D.FID[FID_2D.length_2D-1].real.sig[q]:=FID.real.sig[q];
          FID_2D.FID[FID_2D.length_2D-1].imag.sig[q]:=FID.imag.sig[q];
          FID_2D.FID[FID_2D.length_2D-1].abs.sig[q]:=FID.abs.sig[q];
        end; // q
      end else begin
        FID_2D.FID[FID_2D.length_2D-1].domain:=dmTime;
      end;


      if spinNoise then begin

//        FID.FFT;


        for q:=0 to al-1 do begin
          FID_2D.FID[FID_2D.length_2D-1].real.sig[q]:=
//          FID_2D.FID[FID_2D.length_2D-1].real.sig[q] + FID.real.sig[q];
          FID_2D.FID[FID_2D.length_2D-1].real.sig[q] + FID.abs.sig[q];
          FID_2D.FID[FID_2D.length_2D-1].imag.sig[q]:= 0.0;
         // FID_2D.FID[FID_2D.length_2D-1].imag.sig[q] + FID.imag.sig[q];
          FID_2D.FID[FID_2D.length_2D-1].abs.sig[q]:=
          FID_2D.FID[FID_2D.length_2D-1].abs.sig[q] + FID.abs.sig[q];
        end; // q
      end; // spinNoise


    FID_2D.FID[FID_2D.length_2D-1].actualNA:=ca+step;

    FReady:=false;
    while(not FReady) do begin
      Synchronize(plotData);
      Sleep(1); // 1.00beta7
    end; // while


    Inc(cst);
    if cst=nst then begin
      cst:=0;

      FCA:=FCA+FStep;

      if ca>=na*nacq then begin
        FCA:=na*nacq;
        FaccumFinished:=true;
//        FID_2D.FID[FID_2D.length_2D-1].actualNA:=na;
      end;// else FID_2D.FID[FID_2D.length_2D-1].actualNA:=ca;

    end;


  //  repeat until FReady;  // vbgI܂őҋ@
                          // ̌RCVR1oCgăf[^󂯎Ƃ
                          //     u`v
   // FtransferBusy:=true;
    outBuffer[0]:=Byte(#13);
    FT_Write(receiverHandle,@outBuffer,1,@WR);
         // FPGAV[o1oCg
         // f[^󂯎Ƃ`
         // sendRCVRCommand('0'); ƂQoCgIisR[htj
   // FTransferBusy:=false;

  end; // while

  clearRCVR;

   // sleep(200);
end;
//------------------------------------------------------------------------------

end.
